// ALISP engine v0.4.3b
// ALISP is dedicated to Enota, the girl i'll never forget
// coded by Ketmar // Vampire Avalon (psyc://ketmar.no-ip.org/~Ketmar)
// Understanding is not required. Only obedience.
//
// This program is free software. It comes without any warranty, to
// the extent permitted by applicable law. You can redistribute it
// and/or modify it under the terms of the Do What The Fuck You Want
// To Public License, Version 2, as published by Sam Hocevar. See
// http://sam.zoy.org/wtfpl/COPYING for more details.
//

function FileSearchEx (const name, pathList: string): string;
var
  pl: string;
begin
  pl := StringReplace(pathList, '$(appdir)', ExtractFileDir(ParamStr(0)), [rfReplaceAll, rfIgnoreCase]);
  result := SysUtils.FileSearch(name, pl);
  if result <> '' then result := ExpandFileName(result);
end;


{$R-} //!!!
function ExtStr2Int (const s: string; out res: Integer): Boolean;
// %bin; $hex; #hex; @octal
var
  base, c, dig, n: Integer;
  ch: Char;
  neg: Boolean;
begin
  result := false; res := 0; neg := false;

  c := 1; while (c <= Length(s)) and (s[c] <= ' ') do Inc(c);
  if c > Length(s) then exit;
  if s[c] = '+' then Inc(c)
  else if s[c] = '-' then begin neg := true; Inc(c); end;
  if c > Length(s) then exit;

  if (c+2 <= Length(s)) and (s[c] = '0') and (UpCase(s[c+1]) = 'x') then exit;

  case s[c] of
    '#', '$': begin base := 16; Inc(c); end;
    '%': begin base := 2; Inc(c); end;
    '@': begin base := 8; Inc(c); end;
    else base := 10;
  end;
  if c > Length(s) then exit;

  while (c <= Length(s)) and (s[c] > ' ') do
  begin
    ch := UpCase(s[c]); Inc(c);
    if (ch < '0') or (ch > 'F') or ((ch > '9') and (ch < 'A')) then exit;
    dig := ord(ch)-ord('0'); if dig > 9 then Dec(dig, 7);
    if dig >= base then exit;
    n := res*base;
    if n < res then exit; // overflow check
    Inc(n, dig);
    if n < res then exit; // overflow check
    res := n;
  end;

  if neg then res := -res;

  while (c <= Length(s)) and (s[c] <= ' ') do Inc(c);

  result := (c > Length(s));
end;
