// DarkSpecter ZX Spectum Emulator
// coded by Ketmar // Vampire Avalon (psyc://ketmar.no-ip.org/~Ketmar)
// Understanding is not required. Only obedience.
//
// This program is free software. It comes without any warranty, to
// the extent permitted by applicable law. You can redistribute it
// and/or modify it under the terms of the Do What The Fuck You Want
// To Public License, Version 2, as published by Sam Hocevar. See
// http://sam.zoy.org/wtfpl/COPYING for more details.
//
// dialogs
//
unit dspDialogsU;

interface

uses
  Windows, CommDlg, SysUtils, dspEmuMouseU;


function EmuDialogGetDiskNameToSave (): string;
function EmuDialogGetSnapshotToLoad (): string;
function EmuDialogGetSnapshotToSave (): string;
function EmuDialogGetAnyFileToLoad (): string;


implementation


function EmuDialogGetAnyFileToLoad (): string;
var
  openI: CommDlg.TOpenFileName;
  fName: packed array [0..511] of Char;
  sDir: string;
begin
  EmuUnlockMouse();
  result := '';
  sDir := GetCurrentDir();
  FillChar(openI, SizeOf(openI), 0);
  openI.lStructSize := SizeOf(openI);
  openI.lpstrFilter := 'Any file'#0'*'#0#0;
  fName[0] := #0;
  openI.hWndOwner := emuHWnd;
  openI.lpstrFile := PChar(@fName);
  openI.nMaxFile := SizeOf(fName);
  openI.lpstrTitle := 'Select file';
  openI.Flags := OFN_EXPLORER or OFN_FILEMUSTEXIST or OFN_HIDEREADONLY or
    OFN_LONGNAMES or OFN_NOTESTFILECREATE;
  openI.lpstrInitialDir := PChar(sDir);
  if CommDlg.GetOpenFileName(openI) then
  begin
    result := openI.lpstrFile;
  end;
end;

function EmuDialogGetSnapshotToLoad (): string;
var
  openI: CommDlg.TOpenFileName;
  fName: packed array [0..511] of Char;
  sDir: string;
begin
  EmuUnlockMouse();
  result := '';
  sDir := GetCurrentDir();
  FillChar(openI, SizeOf(openI), 0);
  openI.lStructSize := SizeOf(openI);
  openI.lpstrFilter :=
    'Snapshot, tape & disk files'#0+
      '*.dzs;*.sna;*.z80;*.slt;*.tap;*.tzx;*.trd;*.scl;*.$*;*.scr;*.dmb'+
      ';*.trz;*.scz;*.tpz;*.ztzx'#0+
    'Snapshot files'#0'*.dzs;*.sna;*.z80;*.slt'#0+
    'Disk files'#0'*.trd;*.scl;*.trz;*.scz'#0+
    'Tape files'#0'*.tap;*.tzx;*.tpz;*.ztzx'#0+
    'Hobeta files'#0'*.$*'#0+
    'Screen files'#0'*.scr'#0+
    'Memory dump files'#0'*.dmb'#0+
    'All files'#0'*'#0#0;
  fName[0] := #0;
  openI.hWndOwner := emuHWnd;
  openI.lpstrFile := PChar(@fName);
  openI.nMaxFile := SizeOf(fName);
  openI.lpstrTitle := 'Select snapshot to load';
  openI.Flags := OFN_EXPLORER or OFN_FILEMUSTEXIST or OFN_HIDEREADONLY or
    OFN_LONGNAMES or OFN_NOTESTFILECREATE;
  openI.lpstrInitialDir := PChar(sDir);
  if CommDlg.GetOpenFileName(openI) then
  begin
    result := openI.lpstrFile;
  end;
end;

function EmuDialogGetSnapshotToSave (): string;
var
  openI: CommDlg.TOpenFileName;
  fName: packed array [0..511] of Char;
  sDir: string;
begin
  //if emuFullScreen then CreateEmuWindow(false, emuScale);
  EmuUnlockMouse();
  result := '';
  sDir := GetCurrentDir();
  FillChar(openI, SizeOf(openI), 0);
  openI.lStructSize := SizeOf(openI);
  openI.lpstrFilter := 'Speccy snapshot files'#0'*.dzs;*.z80;*.sna'#0#0;
  fName[0] := #0;
  openI.hWndOwner := emuHWnd;
  openI.lpstrFile := PChar(@fName);
  openI.nMaxFile := SizeOf(fName);
  openI.lpstrTitle := 'Select file to save';
  openI.lpstrDefExt := 'dzs';
  openI.Flags := OFN_EXPLORER or OFN_OVERWRITEPROMPT or OFN_PATHMUSTEXIST or
    OFN_HIDEREADONLY or OFN_LONGNAMES;
  openI.lpstrInitialDir := PChar(sDir);
  if CommDlg.GetSaveFileName(openI) then
  begin
    result := openI.lpstrFile;
  end;
end;

function EmuDialogGetDiskNameToSave (): string;
var
  openI: CommDlg.TOpenFileName;
  fName: packed array [0..511] of Char;
  sDir: string;
begin
  EmuUnlockMouse();
  result := '';
  sDir := GetCurrentDir();
  FillChar(openI, SizeOf(openI), 0);
  openI.lStructSize := SizeOf(openI);
  openI.lpstrFilter := 'DarkSpecter disk files'#0'*.trd;*.scl'#0#0;
  fName[0] := #0;
  openI.hWndOwner := emuHWnd;
  openI.lpstrFile := PChar(@fName);
  openI.nMaxFile := SizeOf(fName);
  openI.lpstrTitle := 'Select disk file to save';
  openI.lpstrDefExt := 'trd';
  openI.Flags := OFN_EXPLORER or OFN_OVERWRITEPROMPT or OFN_PATHMUSTEXIST or
    OFN_HIDEREADONLY or OFN_LONGNAMES;
  openI.lpstrInitialDir := PChar(sDir);
  if CommDlg.GetSaveFileName(openI) then
  begin
    result := openI.lpstrFile;
  end;
end;


end.
