(defun cmd-num-convert-x (num base help)
  (if (eq num "?") (return help))
  (if (string? num)
    (catch (setq num (toint num)))
  )
  (if (int? num) (begin
    (if (neg? num) (setq num (& num $FFFF)))
    (||
      (switch base
        2 "%"
        8 "@"
        16 "$"
        ""
      )
      ;(if (neg? num) "-" "")
      (num-convert (abs num) base)
    ))
   "wtf?"
  )
)

(defun !!cmd-num-convert-2 (cmd args)
  (println (cmd-num-convert-x (safe-car args) 2 "convert number to binary\vusage: bin number"))
)
(defun !!cmd-num-convert-8 (cmd args)
  (println (cmd-num-convert-x (safe-car args) 8 "convert number to octal\vusage: oct number"))
)
(defun !!cmd-num-convert-10 (cmd args)
  (println (cmd-num-convert-x (safe-car args) 10 "convert number to decimal\vusage: dec number"))
)
(defun !!cmd-num-convert-16 (cmd args)
  (println (cmd-num-convert-x (safe-car args) 16 "convert number to hexadecimal\vusage: hex number"))
)


(con-add-cmd "bin" "!cmd-num-convert-2")
(con-add-cmd "oct" "!cmd-num-convert-8")
(con-add-cmd "dec" "!cmd-num-convert-10")
(con-add-cmd "hex" "!cmd-num-convert-16")
