(setq miscutilz *t*)

; checking for defined symbols
(defun defined? (name)
; returns *nil* or symbol value
  (if (setq name (find-symbol name))  (cdr name))
)

(defun bool-to-str (bool) (if bool "tan" "ona"))

(defun boolopt-to-str (name)
  (bool-to-str  (if (setq name (find-symbol name))  (cdr name)))
)

(defun type-name (t)
  (switch t
    -1 "pair"
    1 "int"
    2 "float"
    3 "string"
    4 "primitive"
    5 "vector"
    6 "byte-vector"
    7 "object"
   "unknown"
  )
)

(setq type-pair -1)
(setq type-int 1)
(setq type-float 2)
(setq type-string 3)
(setq type-primitive 4)
(setq type-vector 5)
(setq type-bytevector 6)
(setq type-object 7)


(defun within (n lo hi)
; lo <= n <= hi
  (land (<= lo n) (<= n hi))
)

; string utilities
(defun trim-right (s | c)
  (setq c (length s))
  (while (land (pos? c) (< (nth s c) 33)) (dec-v c))
  (str-mid s 1 c)
)

(defun trim-left (s | c l)
  (setq c 1  l (length s))
  (while (land (<= c l) (< (nth s c) 33)) (inc-v c))
  (str-mid s c)
)

(defun trim-all (s)  (trim-left (trim-right s)))

(defun multiline-to-vector (s | v c)
  (setq v (new-vector 0))
  (while (not-empty-str? s)
    (if (zero? (setq c (str-pos "\v" s))) (setq c (incr (length s))))
    (vec-insert-nth v (length v) (str-mid s 1 (decr c)))
    (setq s (str-mid s (incr c)))
  )
  (if (zero? (length v)) (vec-insert v 0 ""))
  v
)

(defun comma-num (n | c)
  (if (not (string? n)) (setq n (tostr n)))
  (setq c (- (length n) 2))
  (while (> c 1)
    (setq n (str-ins "," n c)  c (- c 3))
  )
  n
)
