// DarkSpecter ZX Spectum Emulator
// coded by Ketmar // Vampire Avalon (psyc://ketmar.no-ip.org/~Ketmar)
// Understanding is not required. Only obedience.
//
// This program is free software. It comes without any warranty, to
// the extent permitted by applicable law. You can redistribute it
// and/or modify it under the terms of the Do What The Fuck You Want
// To Public License, Version 2, as published by Sam Hocevar. See
// http://sam.zoy.org/wtfpl/COPYING for more details.
//
// 128k port i/o
//
unit dsp128kU;

interface

uses
  z80U, dspEmuVarsU, dspMachConstU, dspZXDrawU, dspPortGeneralU;


function PortIn128 (z80: PZ80CPU; port: Word): Byte;
procedure PortOut128 (z80: PZ80CPU; port: Word; b: Byte);


implementation


function PortIn128 (z80: PZ80CPU; port: Word): Byte;
begin
  result := InPortGeneral(z80, port);
end;

procedure PortOut128 (z80: PZ80CPU; port: Word; b: Byte);
var
  scrP: Byte;
  te: Integer;
begin
  if (port and $FF) = $FD then
  begin
    case ((port shr 8) shr 6) of
      0, 1:
        begin
          if (emuLastOut7FFD and $20) <> 0 then exit; // blocked
          if config.pent512 then
          begin
            te := (b and $07) or ((b and $C0) shr 3);
            if te > 7 then Inc(te, 3);
            emuPaging[3] := te;
          end
          else emuPaging[3] := b and $07;

          if (b and $08) > 0 then scrP := 7 else scrP := 5;
          if scrP <> emuScreenPage then
          begin
            //if (emuFramesToSkip < 0) and config.accurateScreenUpdate then
            if emuFramesToSkip < 0 then
            begin
              te := z80.tStates;
              if (te >= emuLineTStates[0]) and (te < emuLineTStates[240]) then
                ZXExUpdateScr(te-1, @emuMemory[emuScreenPage]);
            end;
            emuScreenPage := scrP;
          end;
          emuPaging[0] := 8+((b and $10) shr 4);

          emuLastOut7FFD := b;
          exit;
        end;
    end;
  end;

  OutPortGeneral(z80, port, b);
end;


end.
